(ql:quickload :hot-line)

(defpackage hot-line.app
  (:use :cl)
  (:import-from :lack.builder
                :builder)
  (:import-from :ppcre
                :scan
                :regex-replace)
  (:import-from :hot-line.web
                :*web*)
  (:import-from :hot-line.config
                :config
                :productionp
                :*static-directory*))
(in-package :hot-line.app)

(funcall clack-errors:*clack-error-middleware*
	 (builder
	  (:static
	   :path (lambda (path)
		   (if (ppcre:scan "^(?:/images/|/css/|/js/|/robot\\.txt$|/favicon\\.ico$)" path)
		       path
		       nil))
	   :root *static-directory*)
	  (if (productionp)
	      nil
	      :accesslog)
	  (if (getf (config) :error-log)
	      `(:backtrace
		:output ,(getf (config) :error-log))
	      nil)
	  :session
	  (if (productionp)
	      nil
	      (lambda (app)
		(lambda (env)
		  (let ((datafly:*trace-sql* t))
		    (funcall app env)))))
	  *web*)
         :debug (if (hot-line.config:productionp)
		    nil
		    t)) ; Added as part of clack-error-middleware.
