(defsystem "hot-line"
  :version "0.1.0"
  :author "Craig Oates"
  :license "MIT"
  :depends-on ("clack"
               "lack"
               "caveman2"
               "envy"
               "cl-ppcre"
               "uiop"

               ;; for @route annotation
               "cl-syntax-annot"

               ;; HTML Template
               "djula"

               ;; for DB
               "datafly"
               "sxql"

	       ;; Additional Packages
	       #:clack-errors ; Error report (HTML/template views)
	       #:mito         ; Database ORM
	       #:osicat	      ; Environment variables (dev/prod.)
	       #:ratify       ; Utilites
	       #:sqlite       ; Sqlite database ORM
	       #:hermetic     ; Authentication
	       #:cl-fad       ; Files and directories
	       #:serapeum     ; Pagination
	       )
  :pathname "src/"
  :components (;; Caveman Files
	       (:file "config")
	       (:file "main")	       
	       (:file "db")
	       (:file "view")
	       ;; hot-line Specific Files
	       (:file "models/app-constants")
	       (:file "models/user")
	       (:file "models/file")
	       (:file "services/storage")
	       (:file "services/authentication")
	       (:file "services/validation")
	       (:file "services/convert")
	       (:file "services/user-management")
	       (:file "services/db-management")
	       (:file "services/storage-management")
	       (:file "services/pagination")
	       (:file "services/routing")
	       ;; Caveman Files
	       (:file "web"))
  :description "A proof-of-concept website testing Python and its Bokeh library."
  :build-operation "program-op" ;; leave as is
  :build-pathname "hot-line-nellis"
  :entry-point "hot-line:main"
  :in-order-to ((test-op (test-op "hot-line/test"))))

(defsystem #:hot-line/tests
  :author "Craig Oates"
  :license "MIT"
  :depends-on (#:hot-line
	       #:parachute)
  :pathname "tests/"
  :components ((:file "tests"))
  :description "Test system for hot-line"
  :perform (test-op (op s) (symbol-call :parachute :test :tests)))
